SystemOrganization addCategory: #'Pier-PersistencyManager'!

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:47'!
renameSetUp

kernel := PRKernel named: '####test'.! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:48'!
renameTearDown

PRKernel instances removeAll: (PRKernel instances select: [ :k | k name beginsWith: '####' ]).! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:52'!
testRenameKernel

	self kernel persistency renameKernelTo: '####new'.

	self assert: kernel name = '####new'.

	self assert: (kernel == (PRKernel instanceNamed: '####new')).
	self assert: (self kernelNames includes: '####new').
	self deny: (self kernelNames includes: '####test').

 ! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:47'!
testRenameKernelFailDueToNameTaken

	| k | 

	k := PRKernel named: '####new'.

	self should: [ kernel persistency renameKernelTo: '####new' ] raise: Error.

	self assert: (k == (PRKernel instanceNamed: '####new') )

 ! !

WADispatcherPlugin subclass: #PRSeasideDispatcherPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:45'!
controlPanelClass

	^ PRPierControlPanel 	! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:50'!
execute 

	self requestor call:  (self controlPanelClass forApplication: self target)! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/26/2007 20:22'!
isActive 
	^ target isApplication and: 
		[ target configuration allAttributes anySatisfy: [ :c | c group = #pier]  ]! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/26/2007 21:57'!
label

	^ 'Pier'! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:50'!
priority

	^ 350! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 12/13/2007 03:15'!
copyKernelTo: newName

| newRoot |

self validateNameAvailable: newName.

newRoot := self kernel root copy.

PRKernel named: newName root: newRoot.

	newRoot incomingReferences
		toAll: (newRoot enumerator
			everything contents);
		do: [ :each | each update ].! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 2/27/2007 12:37'!
discarded! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 10/6/2006 07:34'!
exportTo: aPersistency 
 
^ (aPersistency fromPRPersistency: self).! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 05:03'!
exportToPRPersistency: aPRPersistency

! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 06:23'!
fromPRMagmaPersistency: aMagmaPersistency 

^aMagmaPersistency exportToPRPersistency: self  ! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 06:20'!
fromPRPersistency: aPersistency 

^self copySameFrom: aPersistency! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 12/12/2007 23:32'!
renameKernelTo: newName
 
	"although renaming a kernel is straightforward, using this api
 	allows persistency mechanisms to maintain their integrity"

	self validateNameAvailable: newName.

	self kernel name: newName.! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 12/13/2007 05:55'!
setKernel: addToKernel

	"if we are being added to a kernel with nil root, then copy the data from our kernel to the new one"
	
	addToKernel root ifNil: [
		addToKernel root: kernel root.
	].

	kernel := addToKernel.
! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 12/12/2007 23:31'!
validateNameAvailable: newName
 
	PRKernel instances do: [ :each | 
		each name = newName ifTrue: [ self error: 'Name Taken' ] 
	].

	! !

WADecoration subclass: #PRCurrentContextDecoration
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:30'!
context

	^ context ! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:52'!
isGlobal
	^ true! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:43'!
nextPresentersDo: aBlock

	PRCurrentContext use: self during: [
	
		aBlock value: self owner
	]
	! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:26'!
processChildCallbacks: aStream

	PRCurrentContext use: self during: [ super processChildCallbacks: aStream ]! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:25'!
renderContentOn: html

	PRCurrentContext use: self during: [
		self renderOwnerOn: html
	]
	! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:29'!
setContext: c

	context := c! !

WADispatcherControlPanel subclass: #PRPierControlPanel
	instanceVariableNames: 'newKernelName context persistency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRPierControlPanel commentStamp: 'kph 10/3/2006 02:12' prior: 0!
This class provides a seaside configuration tool for pier.!

!PRPierControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:13'!
initialize
	"for seaside version<=2.7"
 
	 ^ self register! !

!PRPierControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:13'!
label

 ^ 'Pier'
 
! !

!PRPierControlPanel methodsFor: 'utilities' stamp: 'kph 12/12/2007 22:07'!
callWidget: widget  titled: title

     self call: (widget
   			addDecoration: (PRCurrentContextDecoration new setContext: self context; yourself);
   	         addDecoration: (WAWindowDecoration new
    	            title: title;
 			   yourself);		

			yourself) 
 
	 ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 04:32'!
confirmSetPersistency
	| old |
	(old := self kernelChoice persistency class) 
		== self newPersistencyClass ifTrue: [^ false].

	^ self confirm: 'Are you sure you want to replace ' , old name , 
	' with ' , self newPersistencyClass name! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 03:01'!
context

	| kernel |

	kernel := self kernel.
 
	^context := (PRContext kernel: kernel ) 
					setUser: kernel adminUser;
					yourself.	

 	
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 03:29'!
doCopyKernel: aKernel 
	| newName |
	newName := self call: (WAInputDialog new label: 'new name').
	self usingAppSession: 
			[[self kernelChoice persistency copyKernelTo: newName] on: Error
				do: [:e | self inform: 'Copy failed: ' , e messageText]]! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:12'!
doDeleteKernel: aKernel

	self	doubleConfirm: ('delete kernel: ', aKernel name)
		thenDo: [ PRKernel instances remove: aKernel ] ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 03:29'!
doManageGroups
	self callWidget: PUGroupsWidget new
		titled: 'Groups for ' , self kernelChoice asString! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 01:51'!
doManageSystem

	self callWidget: PUSystemWidget new
		titled: 'System'! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 03:29'!
doManageUsers
	self callWidget: PUUsersWidget new
		titled: 'Users for ' , self kernelChoice asString! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 4/20/2007 00:40'!
doNewKernel

	self newKernelName ifNotEmpty: [  
		PRKernel instances detect: [ :k | k name = newKernelName ] ifNone: [ PRKernel named: newKernelName ]. 
	]! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 03:29'!
doRenameKernel: aKernel 
	| newName |
	newName := self call: (WAInputDialog new label: 'new name').
	self usingAppSession: 
			[[self kernelChoice persistency renameKernelTo: newName] on: Error
				do: [:e | self inform: 'Rename failed: ' , e messageText]]! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 03:02'!
doSetKernelToServeTo: k

	(k isKindOf: PRKernel)
		ifTrue: [ self application preferenceAt: #kernel put: k.
				 self application preferenceAt: #mainClass put: PRPierMain. 
				 persistency := k persistency ]
		ifFalse: [ self application preferenceAt: #mainClass put: PRPierMain classForServingAllKernels ].

	! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/13/2007 04:56'!
doSetPersistency
	 
	self usingAppSession: 
			[ [persistency := self kernelChoice persistency exportTo: persistency] on: Error
				do: [:e | ^ self error: 'Conversion failed: ' , e messageText] ].
			
	(self confirm: 'Conversion succeeded, commit?') 
		ifFalse: 
			[self usingAppSession: [persistency discarded].
			^ self].
	self usingAppSession: [self kernelChoice persistency: persistency].
	self application clearHandlers! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/3/2006 15:07'!
done

^self answer! !

!PRPierControlPanel methodsFor: 'utilities' stamp: 'kph 9/30/2006 03:24'!
doubleConfirm: message thenDo: aBlock

((self confirm: 'Are you sure you want to ', message) and: 
	[ self confirm: 'Are you REALLY sure you want to ', message ])
	ifTrue: [ 
				^aBlock value.
	].
! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 00:28'!
isApplicationServingAllKernels

	| mainClass |
	
	mainClass := self application preferenceAt: #mainClass.
	
	(mainClass respondsTo: #isServingAllKernels) ifFalse: [ ^ false ].
	
	^ mainClass isServingAllKernels
			 ! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 12/13/2007 03:29'!
kernel
	^ self kernelChoice realize! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 12/13/2007 03:29'!
kernelChoice
	^ self isApplicationServingAllKernels 
		ifTrue: ['All Kernels']
		ifFalse: [self application preferenceAt: #kernel]! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 10/4/2006 00:25'!
newKernelName

^newKernelName ifNil: [ '' ]! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 10/4/2006 00:26'!
newKernelName: aString

newKernelName := aString! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 12/13/2007 00:26'!
newPersistencyClass
	^ self persistency class! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 12/13/2007 03:29'!
newPersistencyClass: aClass 
	persistency class == aClass ifTrue: [^ self].
	persistency := self kernelChoice persistency 
				in: [:current | current class == aClass ifTrue: [current] ifFalse: [aClass new]]! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 12/13/2007 03:29'!
persistency
	^ persistency ifNil: [self kernelChoice persistency]! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 03:00'!
renderContentOn: html

html form: [
	self renderKernelsOn: html.
	
	self renderKernelSelectorOn: html.
  		 
	html break.
	
	self isApplicationServingAllKernels ifFalse: [
	
		self renderPersistencyOn: html.

		html break.
	].
	
	
	
	self isApplicationServingAllKernels ifFalse: [
		self renderManageUsersOn: html.

		html break.
	].	
	
	self renderMiscOn: html.

	html horizontalRule.
 
	html submitButton on: #done of: self.
].! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 03:11'!
renderKernelInstance: kernel on: html
  
	html tableData: [ html text: kernel name ].

	html tableData: [ 
		html small: [ html anchor callback: [ self doDeleteKernel: kernel ] ; text: '(delete)' ] 
	].

	"direct copy doesnt work very well"
	html tableData: [ 
		html small: [ html anchor callback: [ "self doCopyKernel: kernel" ] ; text: '(copy)' ] 
	].

	html tableData: [ 
		html text:  kernel persistency class.
	].
 

 ! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 03:29'!
renderKernelSelectorOn: html 
	| list |
	(html heading)
		level: 4;
		with: 'Serving:'.
	list := PRKernel instances asOrderedCollection.
	list add: 'All Kernels'.
	(html select)
		selected: self kernelChoice;
		list: list;
		beSubmitOnChange;
		callback: [:k | self doSetKernelToServeTo: k].
	self isApplicationServingAllKernels 
		ifFalse: 
			[html space.
			html small: 
					[(html anchor)
						callback: [self doRenameKernel: self kernelChoice];
						with: '(rename)']]! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 01:50'!
renderKernelsOn: html

	html heading level:4 ; with: 'Kernels:'.

	html table id: 'kernels'; with: [
		PRKernel instances  do: [ :item | 
			html tableRow: [
				self renderKernelInstance: item on: html
			].
		].
	].

	html textInput size: 10;
		 on: #newKernelName of: self. 
	html submitButton 
		on: #doNewKernel of: self; 
		text: 'New Kernel'.! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 03:29'!
renderManageUsersOn: html 
	(self kernelChoice respondsTo: #users) ifFalse: [^ self].
	(html heading)
		level: 4;
		with: 'Security:'.
	(html submitButton)
		on: #doManageUsers of: self;
		text: 'Users'.
	(html submitButton)
		on: #doManageGroups of: self;
		text: 'Groups'! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 01:51'!
renderMiscOn: html

	Smalltalk at: #PUSystemWidget ifAbsent: [ ^self ].

	html heading level: 4; with: 'System:'.

	html submitButton on: #doManageSystem of: self.
 	 
 	! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 05:58'!
renderPRBackupToMagmaPersistencyOn: html
^ super renderPRImagePersistencyOn: html
  ! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 02:29'!
renderPRImagePersistencyOn: html
 
	html text: ' image: '.
	html text: SmalltalkImage current imageName.
	html text: ' duration: '.
	html textInput 
		size: 10; 
		value: persistency duration asSeconds // 60 ;
		callback: [ :v | persistency duration: v asInteger minutes ];
		yourself.
	html text: ' mins'.

	^ true
	! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/13/2007 03:29'!
renderPersistencyOn: html 
	| selector action |
	self kernelChoice ifNil: [^ self].
	(html heading)
		level: 4;
		with: 'Persistency:'.
	(html select)
		list: PRPersistency allSubclasses;
		on: #newPersistencyClass of: self;
		beSubmitOnChange;
		yourself.
	selector := ('render' , self persistency class name , 'On:') asSymbol.
	action := (self respondsTo: selector) 
				ifTrue: [(self perform: selector with: html) ifTrue: [#change]].
	self persistency ~= self kernelChoice persistency 
		ifTrue: [action := #migrate].
	action == #change ifTrue: [html submitButton text: 'Change'].
	action == #migrate 
		ifTrue: 
			[(html submitButton)
				callback: [self confirmSetPersistency ifTrue: [self doSetPersistency]];
				text: 'Migrate']! !
PRPierControlPanel initialize!
